untyped
global function ScoreboardForTTDMInit

const SCOREBOARD_ENEMY_COLOR = <ENEMY_R / 255.0, ENEMY_G / 255.0, ENEMY_B / 255.0>
const SCOREBOARD_FRIENDLY_COLOR = <FRIENDLY_R / 255.0, FRIENDLY_G / 255.0, FRIENDLY_B / 255.0>
const SCOREBOARD_DEAD_COLOR = < 224 / 255.0, 65 / 255.0 ,65 / 255.0>
// const SCOREBOARD_DEAD_COLOR = <0.2, 0.2, 0.2>
const SCOREBOARD_DOOMED_COLOR = < 224 / 255.0, 65 / 255.0 ,65 / 255.0>
const SCOREBOARD_BG_ALPHA = 0.35

const table<string, vector >  colors = {
	["green"] = < 50, 205, 50 > ,
	["blue"] = < 65,105 ,225> ,
	["yellow"] = < 224,155 ,65> ,
	["red"] = < 224,65 ,65>
}

const int SCORE_SEP = 5000
const int SCORE_BASELINE = 10000

void function ScoreboardForTTDMInit(){
    thread Monitor()
}

void function Monitor(){
    WaitFrame()


	GameMode_AddScoreboardColumnData( TITAN_BRAWL, "#SCOREBOARD_ASSISTS", PGS_ASSISTS, 2 )
	// AddCallback_OnScoreboardPlayerUpdate(SetDamagePerLife)
    AddCallback_OnScoreboardPlayerUpdate(replaceScoreboard)
	GameMode_SetScoreCompareFunc( "ttdm", CompFunc4TTDM )
	// AddCreateCallback( "player", OnPlayerCreated )
}

// 0,1,2 击杀、死亡、伤害
int function CompFunc4TTDM(entity p1, entity p2) {
	array < int > p1Scores = GetPlayerScores(p1)
	array < int > p2Scores = GetPlayerScores(p2)

	// // 伤害差距在允许的范围内
	// if (abs(p1Scores[2] - p2Scores[2]) < SCORE_SEP) {
	// 	// 伤害/生命更大
	// 	if ((p1Scores[2] / (p1Scores[1] +1)) < (p2Scores[2] / (p2Scores[1]+1))) {
	// 		return 1
	// 	}
	// 	else
	// 		return -1
	// // 队友之间伤害差距过大
	// }else if (p1Scores[2] < p2Scores[2]) {
	// 	return 1
	// }
	// else
	// 	return -1


	// by damage
	if (p1Scores[2] < p2Scores[2])
		return 1
	else
		return -1

	return 0
}

array<int> function GetPlayerScores(entity player) {
	array<string> headers = GameMode_GetScoreboardColumnTitles( GAMETYPE )
	array<int> playerGameStats = GameMode_GetScoreboardColumnScoreTypes( GAMETYPE )
	array<int> numDigits = GameMode_GetScoreboardColumnNumDigits( GAMETYPE )


	int playerScore1 = 0
	int playerScore2 = 0
	int playerScore3 = 0
	int playerScore4 = 0
	int playerScore1NumDigits = 2
	int playerScore2NumDigits = 2
	int playerScore3NumDigits = 2
	int playerScore4NumDigits = 2
	string playerScore1Header
	string playerScore2Header
	string playerScore3Header
	string playerScore4Header

	int numScoreColumns = headers.len()

	switch ( numScoreColumns )
	{
		case 4:
			playerScore4Header = headers[ 3 ]
			playerScore4 = player.GetPlayerGameStat( playerGameStats[ 3 ] )
			playerScore4NumDigits = numDigits[ 3 ]

		case 3:
			playerScore3Header = headers[ 2 ]
			playerScore3 = player.GetPlayerGameStat( playerGameStats[ 2 ] )
			playerScore3NumDigits = numDigits[ 2 ]

		case 2:
			playerScore2Header = headers[ 1 ]
			playerScore2 = player.GetPlayerGameStat( playerGameStats[ 1 ] )
			playerScore2NumDigits = numDigits[ 1 ]

		case 1:
			playerScore1Header = headers[ 0 ]
			playerScore1 = player.GetPlayerGameStat( playerGameStats[ 0 ] )
			playerScore1NumDigits = numDigits[ 0 ]
	}

	return [playerScore1, playerScore2, playerScore3, playerScore4]
}


int function IconIndex() {
    return GetConVarInt("mp_scoreboard_next_index")
}

int function UpdateIconIndex(int index) {
    SetConVarInt("mp_scoreboard_next_index", index)
    return IconIndex()
}

bool function IsTLVEnable() {
    try {
      string value = GetConVarString("enable_primaries_display")
        return true;
    } catch (exception){

    }
    return false;
}

// replace the scoreboard
void function replaceScoreboard(entity player, int index, int team, SuperiorFile file)
{
	var elemTable = file.playerElems[team][index]
	var rui = Hud_GetRui( elemTable.background )
	// printSth()
	if (! IsTLVEnable()) {
		for (int i = 0; i < 6; i++) {
			RuiSetImage( rui, "extraIcon" + i, $"" )
		}
	}

	if (IsEnemy(player)) {
		return
	}


	if(IsAlive(player))
	{
		//Logger.Info("alive")
		entity soul = GetSoulFromPlayer(player)
		entity titan = null
		asset titanIcon
		int currentExtraIconIndex = 0

		if(player.IsTitan())
		{
			titan = soul.GetTitan()
			//Logger.Info(GetTitanCharacterName(titan))
			titanIcon = GetIconForTitanClass(GetTitanCharacterName(titan))
			// class
			RuiSetImage( rui, "extraIcon" + currentExtraIconIndex++, titanIcon )

			// only server can have everyones loadouts
			if (player == GetLocalClientPlayer()) {
			// TitanLoadoutDef loadout = GetTitanLoadoutForPlayer( player ) // GetTitanLoadoutForPlayer not work
			// TitanLoadoutDef loadout = GetTitanSpawnLoadout( player )
			TitanLoadoutDef loadout = GetActiveTitanLoadout( player )
			// kit1
			// print("kit1 " + GetItemName( loadout.passive1 ))
			RuiSetImage( rui, "extraIcon" + currentExtraIconIndex++, GetItemImage( loadout.passive1 ) )

			// kit2
			// print("kit2 " + GetItemName( loadout.passive2 ) )
			RuiSetImage( rui, "extraIcon" + currentExtraIconIndex++, GetItemImage( loadout.passive2 ) )
			}


			if (PlayerHasWeapon(player, "mp_titanability_electric_smoke")) {
				// print("electric_smoke " +  GetItemName( loadout.passive3 ) )
				RuiSetImage( rui, "extraIcon" + currentExtraIconIndex++, $"rui/titan_loadout/tactical/titan_tactical_electric_smoke" )
				// try {
				// 	player.SetTitle(player.GetTitleForUI() + " S")
				// } catch (exception){
				// 	print(exception)
				// }
				// AddOverHead(player, $"rui/titan_loadout/tactical/titan_tactical_electric_smoke")
            }

			if ( !IsWatchingReplay() )
				if (IsCoreChargeAvailable(player, player.GetTitanSoul())) {
					// print("core ready " +  GetItemName( loadout.passive3 ) )
					entity weapon = player.GetOffhandWeapon( OFFHAND_EQUIPMENT )
					RuiSetImage( rui, "extraIcon" + currentExtraIconIndex++, GetWeaponInfoFileKeyFieldAsset_WithMods_Global( weapon.GetWeaponClassName(), weapon.GetMods(), "hud_icon" ))
					// try {
					// 	player.SetTitle(player.GetTitleForUI() + " C")
					// } catch (exception){
					// 	print(exception)
					// }
					// AddOverHead(player, GetWeaponInfoFileKeyFieldAsset_WithMods_Global( weapon.GetWeaponClassName(), weapon.GetMods(), "hud_icon" ))
				}

            UpdateIconIndex(currentExtraIconIndex)


			// bg color
			SetBgDueToHealth(rui, player)
		}
	}
}

bool function IsEnemy(entity player) {
	return GetLocalClientPlayer().GetTeam() != player.GetTeam()
}

void function SetDamagePerLife(entity player, int index, int team, SuperiorFile file) {
	array < int > playerScores = GetPlayerScores(player)
	var scoreHeaderRui = Hud_GetRui(file.header.scoreHeader)
	var rowRui = Hud_GetRui( file.playerElems[team][index].background )

	int damagePerLife = playerScores[2] / (playerScores[1] + 1)
}

void function SetBgDueToHealth(var rui, entity player) {
	entity soul = player.GetTitanSoul()
	if ( !IsValid( soul ) )
		return

		int health = player.GetHealth()
		int maxHealth = player.GetMaxHealth()
		float healthPercent = ((maxHealth > 0) ? (health.tofloat() / maxHealth.tofloat()) : 1.0)

	vector color = < 0, 0, 0>;
	// if (soul.IsDoomed()) {
	// 	color = colors["red"]/ 255.0
	// }
	// else
	// {

	// 	if (healthPercent >= 0.8) {
	// 		color = colors["green"]/ 255.0
	// 		// RuiSetFloat3( rui, "textColor", <1.0, 1.0, 1.0> )
	// 	}
	// 	else if (healthPercent >= 0.5) {
	// 		color = colors["blue"]/ 255.0
	// 		// RuiSetFloat3( rui, "textColor", <1.0, 1.0, 1.0> )
	// 	}
	// 	else
	// 	{
	// 		color = colors["yellow"]/ 255.0
	// 		// RuiSetFloat3( rui, "textColor", <0.0, 0.0, 0.0> )
	// 	}

	// }

	vector initialColor = player.GetTeam() == GetLocalClientPlayer().GetTeam() ? SCOREBOARD_FRIENDLY_COLOR : SCOREBOARD_ENEMY_COLOR
	color = initialColor - (initialColor - SCOREBOARD_DEAD_COLOR) * (1 - healthPercent)

	// printt("color", color)
	if (color == < 0, 0, 0>) {
		return
	}
	if (soul.IsDoomed()) {
		color = SCOREBOARD_DOOMED_COLOR
	}
	RuiSetFloat3( rui, "bgColor", color )

	float deadAlpha = 0.0
	float alpha = SCOREBOARD_BG_ALPHA
	// alpha = deadAlpha + (SCOREBOARD_BG_ALPHA - deadAlpha) * healthPercent
	RuiSetFloat( rui, "bgAlpha", alpha )
}
